"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.dispatchSigninCheck = exports.dispatchSignin = undefined;

var _activity = require("../constants/activity.js");

var _api = require("../constants/api.js");

var _redux = require("../utils/redux.js");

/**
 * 个人签到
 * @param {*} id 
 */
var dispatchSignin = exports.dispatchSignin = function dispatchSignin(id) {
  return (0, _redux.createAction)({
    url: _api.API_ACTIVITY_SIGNIN + "/" + id,
    type: _activity.ACTIVITY_SIGNIN,
    method: 'POST'
  });
};

/**
 * 判断是否签到
 * @param {*} id 
 */
var dispatchSigninCheck = exports.dispatchSigninCheck = function dispatchSigninCheck(id) {
  return (0, _redux.createAction)({
    url: _api.API_ACTIVITY_SIGNIN + "/" + id + "/isChecked",
    type: _activity.ACTIVITY_SIGNIN
  });
};