"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.dispatchCardUnlike = exports.dispatchCardLike = exports.dispatchCardList = exports.dispatchCardInfo = undefined;

var _card = require("../constants/card.js");

var _api = require("../constants/api.js");

var _redux = require("../utils/redux.js");

/**
 * 获取卡片信息
 * @param {*} id 
 */
var dispatchCardInfo = exports.dispatchCardInfo = function dispatchCardInfo(id) {
  return (0, _redux.createAction)({
    url: _api.API_CARDS_LIST + "/" + id,
    type: _card.CARD_INFO
  });
};

/**
 * 获取置业顾问列表
 */
var dispatchCardList = exports.dispatchCardList = function dispatchCardList(payload) {
  return (0, _redux.createAction)({
    url: "" + _api.API_CARDS_LIST,
    type: _card.CARD_LIST,
    payload: payload
  });
};

/**
 * 卡片点赞
 * @param {*} id 
 */
var dispatchCardLike = exports.dispatchCardLike = function dispatchCardLike(id) {
  return (0, _redux.createAction)({
    url: _api.API_CARDS_LIKE + "/" + id,
    type: _card.CARD_LIKE,
    method: 'POST'
  });
};

/**
 * 卡片取消点赞
 * @param {*} id 
 */
var dispatchCardUnlike = exports.dispatchCardUnlike = function dispatchCardUnlike(id) {
  return (0, _redux.createAction)({
    url: _api.API_CARDS_LIKE + "/" + id,
    type: _card.CARD_UNLIKE,
    method: 'DELETE'
  });
};