"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.dispatchProjectDetail = exports.dispatchProjectList = undefined;

var _project = require("../constants/project.js");

var _api = require("../constants/api.js");

var _redux = require("../utils/redux.js");

/**
 * 获取楼盘列表
 * @param {*} payload 
 */
var dispatchProjectList = exports.dispatchProjectList = function dispatchProjectList(payload) {
  return (0, _redux.createAction)({
    url: "" + _api.API_ITEMS_LIST,
    type: _project.PROJECT_LIST,
    payload: payload
  });
};

/**
 * 获取项目信息
 * @param {*} id 
 */
var dispatchProjectDetail = exports.dispatchProjectDetail = function dispatchProjectDetail(id) {
  return (0, _redux.createAction)({
    url: _api.API_ITEMS_DETAIL + "/" + id,
    type: _project.PROJECT_DETAIL
  });
};