"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.dispatchPointsAddress = exports.dispatchPointsRule = exports.dispatchPointsRecords = exports.dispatchGoodsExchangeRecords = exports.dispatchGoodsExchange = exports.dispatchGoodsDetail = exports.dispatchGoodsList = undefined;

var _shop = require("../constants/shop.js");

var _api = require("../constants/api.js");

var _redux = require("../utils/redux.js");

/**
 * 商品列表
 * @param {*} payload
 */
var dispatchGoodsList = exports.dispatchGoodsList = function dispatchGoodsList(payload) {
  return (0, _redux.createAction)({
    url: _api.API_GOODS_LIST,
    type: _shop.GOODS_LIST,
    payload: payload
  });
};

/**
 * 商品详情
 * @param {*} id
 */
var dispatchGoodsDetail = exports.dispatchGoodsDetail = function dispatchGoodsDetail(id) {
  return (0, _redux.createAction)({
    url: _api.API_GOODS_LIST + "/" + id,
    type: _shop.GOODS_DETAIL
  });
};

/**
 * 商品兑换
 * @param {*} id
 */
var dispatchGoodsExchange = exports.dispatchGoodsExchange = function dispatchGoodsExchange(id) {
  return (0, _redux.createAction)({
    url: _api.API_GOODS_EXCHANGE + "/" + id,
    type: _shop.GOODS_EXCHANGE,
    method: 'POST'
  });
};

/**
 * 商品兑换记录
 * @param {*} payload
 */
var dispatchGoodsExchangeRecords = exports.dispatchGoodsExchangeRecords = function dispatchGoodsExchangeRecords(payload) {
  return (0, _redux.createAction)({
    url: "" + _api.API_GOODS_EXCHANGE_RECORDS,
    type: _shop.GOODS_EXCHANGE_RECORDS,
    payload: payload
  });
};

/**
 * 积分记录
 * @param {*} payload
 */
var dispatchPointsRecords = exports.dispatchPointsRecords = function dispatchPointsRecords(payload) {
  return (0, _redux.createAction)({
    url: _api.API_POINTS_RECORDS,
    type: _shop.POINTS_RECORDS,
    payload: payload
  });
};

/**
 * 积分规则
 * @param {*} payload
 */
var dispatchPointsRule = exports.dispatchPointsRule = function dispatchPointsRule(payload) {
  return (0, _redux.createAction)({
    url: _api.API_POINTS_RULE,
    type: _shop.POINTS_RULE,
    payload: payload
  });
};

/**
 * 请求地址
 * @param {*} payload
 */
var dispatchPointsAddress = exports.dispatchPointsAddress = function dispatchPointsAddress(payload) {
  return (0, _redux.createAction)({
    url: "" + _api.API_POINTS_ADRESS,
    type: _shop.POINTS_ADRESS,
    payload: payload,
    method: 'PUT'
  });
};