"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.dispatchMyReport = exports.dispatchCustomerInfo = exports.dispatchUserGoods = exports.dispatchUserSignin = exports.dispatchUpdateUserInfoNew = exports.dispatchUpdateUserInfo = undefined;

var _user = require("../constants/user.js");

var _api = require("../constants/api.js");

var _redux = require("../utils/redux.js");

/**
 * 获取用户信息
 * @param {*} payload
 */
var dispatchUpdateUserInfo = exports.dispatchUpdateUserInfo = function dispatchUpdateUserInfo(payload) {
  return (0, _redux.createAction)({
    url: _api.API_USER_INFO,
    type: _user.USER_INFO,
    payload: payload,
    method: 'POST'
  });
};

// export const dispatchQueryUserInfo = payload => createAction({
//   url: API_QUERY_USER_INFO,
//   type: USER_QUERY_INFO,
//   payload
// })

var dispatchUpdateUserInfoNew = exports.dispatchUpdateUserInfoNew = function dispatchUpdateUserInfoNew(id) {
  return (0, _redux.createAction)({
    url: _api.API_QUERY_USERINFO_BYID + "/" + id,
    type: _user.UPDATE_USER_INFO
  });
};

/**
 * 个人签到
 * @param {*} payload
 */
var dispatchUserSignin = exports.dispatchUserSignin = function dispatchUserSignin(payload) {
  return (0, _redux.createAction)({
    url: _api.API_USER_SIGNIN,
    type: _user.USER_SIGNIN,
    payload: payload,
    method: 'POST'
  });
};

/**
 * 更新我的商品兑换记录
 * @param {*} payload
 */
var dispatchUserGoods = exports.dispatchUserGoods = function dispatchUserGoods(payload) {
  return function (dispatch) {
    return dispatch({ type: _user.USER_GOODS, payload: payload });
  };
};

/**
 * 我的客户列表
 * @param {*} payload
 */
var dispatchCustomerInfo = exports.dispatchCustomerInfo = function dispatchCustomerInfo(payload) {
  return (0, _redux.createAction)({
    url: _api.API_QUERY_CUSTOMER_INFO,
    type: '',
    payload: payload,
    method: 'GET'
  });
};
/**
 * 我报备的客户列表
 * @param {*} payload
 */
var dispatchMyReport = exports.dispatchMyReport = function dispatchMyReport(payload) {
  return (0, _redux.createAction)({
    url: _api.API_QUERY_MYREPORT,
    type: '',
    payload: payload,
    method: 'GET'
  });
};