"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require("./npm/@tarojs/async-await/index.js");

var _index = require("./npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _index3 = require("./npm/@tarojs/redux/index.js");

var _tools = require("./utils/tools.js");

var _common = require("./services/common.js");

var _user = require("./services/user.js");

var _city = require("./constants/city.js");

var _user2 = require("./constants/user.js");

var _ready = require("./utils/ready.js");

var _ready2 = _interopRequireDefault(_ready);

var _login = require("./utils/login.js");

var _login2 = _interopRequireDefault(_login);

var _index4 = require("./store/index.js");

var _index5 = _interopRequireDefault(_index4);

var _im = require("./utils/im.js");

var _im2 = _interopRequireDefault(_im);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var store = (0, _index5.default)();

(0, _index3.setStore)(store);

if (_index3.ReduxContext.Provider) {
  _index3.ReduxContext.Provider({
    store: store
  });
  _index3.ReduxContext.Provider({
    store: store
  });
}

var _App = function (_BaseComponent) {
  _inherits(_App, _BaseComponent);

  function _App() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, _App);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = _App.__proto__ || Object.getPrototypeOf(_App)).call.apply(_ref, [this].concat(args))), _this), _this.config = {
      debug: false,
      permission: {
        "scope.userLocation": {
          "desc": "你的位置信息将用于显示当前区域信息"
        }
      },
      pages: ['pages/person/index', 'pages/activity/activity', 'pages/shop/index', 'pages/project/index', 'pages/project/detail/index', 'pages/activity/assemblePage', 'pages/activity/assistancePage', 'pages/person/spread/index', 'pages/card/index', 'pages/agent/become/index', 'pages/im/list/index', 'pages/agent/invitation/index', 'pages/agent/client/index', 'pages/person/myGuest/index', 'pages/person/personDetail/index', 'pages/person/personDetail/editDetail/index', 'pages/person/login/index', 'pages/person/myGuest/editGuest/index', 'pages/shop/rule/index', 'pages/person/authorize/index', 'pages/project/map/index', 'pages/agent/index', 'pages/shop/integralDetail/index', 'pages/auth/index', 'pages/card/list/index', 'pages/agent/recommend/index',
      // 'pages/activity/index',
      'pages/report/index', 'pages/project/list/index', 'pages/report/login/index', 'pages/project/floor/index', 'pages/im/index', 'pages/activity/detail/index', 'pages/activity/detail/assistance', 'pages/activity/detail/assemble', 'pages/news/detail/index', 'pages/shop/record/index', 'pages/card/register/index', 'pages/report/detail/index', 'pages/policy/index', 'pages/policy/detail/index', 'pages/toolKit/index', 'pages/toolKit/calculateResult/index', 'pages/project/album/index',
      // 'pages/news/index',
      'pages/person/favorite/index', 'pages/city/index', 'pages/agent/progress/index', 'pages/shop/detail/index', 'pages/signin/index', 'pages/card/fans/index', 'pages/person/feedback/index'],
      window: {
        backgroundTextStyle: 'light',
        navigationBarBackgroundColor: '#BB9C79',
        navigationBarTitleText: '橙蕉',
        navigationBarTextStyle: 'white'

      },
      tabBar: {
        color: '#666',
        selectedColor: '#BB9C79',
        list: [{
          pagePath: "pages/project/index",
          text: "首页",
          iconPath: './assets/tabbar/index1.png',
          selectedIconPath: './assets/tabbar/index2.png'
        }, {
          pagePath: "pages/shop/index",
          text: "积分商城",
          iconPath: './assets/tabbar/shop1.png',
          selectedIconPath: './assets/tabbar/shop2.png'
        }, {
          pagePath: "pages/activity/activity",
          text: "活动",
          iconPath: './assets/tabbar/activity1.png',
          selectedIconPath: './assets/tabbar/activity2.png'
        }, {
          pagePath: "pages/person/index",
          text: "我的",
          iconPath: './assets/tabbar/mine1.png',
          selectedIconPath: './assets/tabbar/mine2.png'
        }]
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(_App, [{
    key: "componentDidHide",
    value: function componentDidHide() {
      _ready2.default.close();
      _im2.default.closeSocket();
    }
  }, {
    key: "componentDidShow",
    value: function componentDidShow() {
      var _this2 = this;

      console.info('app componentDidShow');
      console.info('router1', this.$router.params);
      console.info('ready status1', _ready2.default);

      // 获取城市列表
      (0, _common.queryCityList)().then(function (payload) {
        store.dispatch({ type: _city.CITY_LIST, payload: payload });

        // 获取router参数
        _this2.getRouterParams().then(function (router) {
          _index2.default.setStorageSync('router', router);
          console.info('router2:', router);
          var payload = router.query;
          // login

          (0, _login2.default)(payload, function (res) {
            // 获取未读消息
            var personId = res.person.personId;

            (0, _user.queryUserInfo)(personId).then(function (info) {
              var unReadNum = info.unReadNum;

              store.dispatch({ type: _user2.ASSIGN_UNREADNUM, payload: { unReadNum: unReadNum } });
              _im2.default.createSocket({ id: personId });
              _im2.default.wss.onMessage(function (data) {
                store.dispatch({ type: _user2.INCREASE_UNREADNUM });
              });
            });

            var data = Object.assign({}, payload, {
              event: 'start',
              propertyName: '进入小程序',
              data: ''
            });
            (0, _common.savePoint)(data);
          });
        });
      });

      var updateManager = wx.getUpdateManager();
      updateManager.onCheckForUpdate(function (res) {
        // 请求完新版本信息的回调
        console.info('新版本是否更新:', res.hasUpdate);
      });

      updateManager.onUpdateReady(function () {
        wx.showModal({
          title: '更新提示',
          content: '新版本已经准备好，是否重启应用？',
          success: function success(res) {
            if (res.confirm) {
              // 新的版本已经下载好，调用 applyUpdate 应用新版本并重启
              updateManager.applyUpdate();
            }
          }
        });
      });
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      console.info('app componentDidMount');
    }
  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      console.info('app componentWillMount');
    }
  }, {
    key: "getRouterParams",
    value: function getRouterParams() {
      var _this3 = this;

      return new Promise(function (resolve) {
        var router = _this3.$router.params;
        var paramsId = router.query.scene;


        if (paramsId) {
          // 扫码进入
          (0, _common.getCodeScene)(paramsId).then(function (res) {
            var params = JSON.parse(res).scene;
            var _from = (0, _tools.getQueryString)(params, 'from');
            var _recommender = (0, _tools.getQueryString)(params, 'recommender');
            var id = (0, _tools.getQueryString)(params, 'id');
            var agentCode = (0, _tools.getQueryString)(params, 'agentCode');
            router.query = Object.assign(router.query, {
              id: id,
              paramsId: paramsId,
              from: _from,
              recommender: _recommender,
              params: params,
              targetId: id,
              agentCode: agentCode
            });

            resolve(router);
          });
        } else {
          router.query = Object.assign(router.query, {
            paramsId: '',
            from: 'search',
            recommender: ''
          });

          resolve(router);
        }
      });
    }
    // 在 App 类中的 render() 函数没有实际作用
    // 请勿修改此函数

  }, {
    key: "_createData",
    value: function _createData() {}
  }]);

  return _App;
}(_index.Component);

exports.default = _App;

App(require('./npm/@tarojs/taro-weapp/index.js').default.createApp(_App));
_index2.default.initPxTransform({
  "designWidth": 750,
  "deviceRatio": {
    "640": 1.17,
    "750": 1,
    "828": 0.905
  }
});