"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _class, _temp2;

var _index = require("../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _tools = require("../../utils/tools.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var emptyImg = "/assets/empty.png";

/**
 * 参考文档 https://taro-ext.jd.com/plugin/view/5d2749424cc17c655cfda575
 */
var ListView = (_temp2 = _class = function (_BaseComponent) {
  _inherits(ListView, _BaseComponent);

  function ListView() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ListView);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ListView.__proto__ || Object.getPrototypeOf(ListView)).call.apply(_ref, [this].concat(args))), _this), _this.$usedState = ["anonymousState__temp", "anonymousState__temp2", "anonymousState__temp3", "className", "canScrollY", "showTipFreedText", "showTipText", "downLoading", "showChildren", "showErrorText", "showRenderError", "showEmptyText", "emptyImg", "showRenderEmpty", "footerLoading", "customFooterLoading", "footerLoaded", "customFooterLoaded", "deactivate", "tipFreedText", "activate", "tipText", "release", "emptyText", "footerLoadingText", "noMore", "footerLoadedText", "touchScrollTop", "lowerDistance", "scrollTop", "startY", "lowerLoading", "needPullDown", "isInit", "blockStyle", "needInit", "distanceToRefresh", "hasMore", "style", "isEmpty", "isError", "launch", "indicator", "children", "renderError", "renderEmpty", "renderFooterLoading", "renderFooterLoaded"], _this.scrollView = {}, _this.state = {
      canScrollY: true,
      touchScrollTop: 0,
      lowerDistance: 0,
      scrollTop: 0,
      startY: 0,
      downLoading: false,
      lowerLoading: false,
      needPullDown: true,
      isInit: false,
      blockStyle: {
        height: 0 + "px",
        transition: "none"
      }
    }, _this.touchEvent = function (e) {
      var startY = _this.state.startY;
      var type = e.type,
          touches = e.touches;
      var onPullDownRefresh = _this.props.onPullDownRefresh;

      if (!onPullDownRefresh) {
        return;
      }switch (type) {
        case 'touchstart':
          {
            _this.setState({
              touchScrollTop: _this.state.scrollTop,
              startY: touches[0].clientY,
              needPullDown: true
            });
            break;
          }
        case 'touchmove':
          {
            // const { clientY: preClientY = 1 } = this.state.blockStyle;
            var clientY = touches[0].clientY;
            var touchScrollTop = _this.state.touchScrollTop;

            var height = Math.floor((clientY - startY) / 5);
            // 拖动方向不符合的不处理
            if (height < 0 || touchScrollTop > 5) {
              return;
            }_this.setState({ canScrollY: false });

            e.preventDefault(); // 阻止默认的处理方式(阻止下拉滑动的效果)
            if (height > 0 && height < 80) {
              if (height < 50) {
                _this.setState({ needPullDown: true });
              } else {
                _this.setState({ needPullDown: false });
              }
              _this.setState({
                blockStyle: {
                  height: height + "px",
                  transition: 'none'
                }
              });
            }
            break;
          }
        case 'touchend':
          {
            if (!_this.state.needPullDown) {
              _this.fetchInit();
            } else {
              _this.resetLoad(0);
            }
            break;
          }
        case 'touchcancel':
          {
            if (!_this.state.needPullDown) {
              _this.fetchInit();
            } else {
              _this.resetLoad(0);
            }
            break;
          }
        default:
          {
            // console.log('foo');
          }
      }
    }, _this.fetchInit = function () {
      var onPullDownRefresh = _this.props.onPullDownRefresh;

      _this.resetLoad(30);
      if (onPullDownRefresh) {
        _this.props.onPullDownRefresh(function () {
          _this.setState({ isInit: true });
          _this.resetLoad(0, function () {
            _this.setState({ isInit: false });
          });
        });
      }
    }, _this.resetLoad = function () {
      var height = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
      var cb = arguments[1];
      var distanceToRefresh = _this.props.distanceToRefresh;

      var canScrollY = false;
      if (height === 0) {
        canScrollY = true;
      }
      _this.setState({
        canScrollY: canScrollY,
        blockStyle: {
          height: height + "px",
          transition: 'height 300ms'
        },
        needPullDown: true,
        downLoading: height === distanceToRefresh
      });
      // todo 监听真正动画结束
      setTimeout(function () {
        if (cb) {
          cb();
        }
      }, 400);
    }, _this.handleScrollToLower = function () {
      (0, _tools.throttle)(function () {
        _this.getMore();
      });
    }, _this.getMore = function () {
      var _this$props = _this.props,
          onScrollToLower = _this$props.onScrollToLower,
          hasMore = _this$props.hasMore;
      var lowerLoading = _this.state.lowerLoading;

      if (hasMore && !lowerLoading && onScrollToLower) {
        _this.setState({ lowerLoading: true }, function () {
          _this.props.onScrollToLower(function () {
            setTimeout(function () {
              _this.setState({ lowerLoading: false });
            }, 500);
          });
        });
      }
    }, _this.onScroll = function (e) {
      var _e$detail = e.detail,
          scrollTop = _e$detail.scrollTop,
          scrollHeight = _e$detail.scrollHeight;

      _this.setState({ scrollTop: scrollTop, lowerDistance: scrollHeight - scrollTop });
    }, _this.customComponents = [], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ListView, [{
    key: "_constructor",
    value: function _constructor(props) {
      var _this2 = this;

      _get(ListView.prototype.__proto__ || Object.getPrototypeOf(ListView.prototype), "_constructor", this).call(this, props);

      this.$$refs = [{
        type: "dom",
        id: "RmFIK",
        refName: "",
        fn: function fn(node) {
          _this2.scrollView = node;
        }
      }];
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.needInit) {
        this.fetchInit();
      }
    }
  }, {
    key: "_createData",
    value: function _createData() {
      var _this3 = this;

      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;

      var _props = this.__props,
          style = _props.style,
          tipFreedText = _props.tipFreedText,
          tipText = _props.tipText,
          hasMore = _props.hasMore,
          noMore = _props.noMore,
          isEmpty = _props.isEmpty,
          emptyText = _props.emptyText,
          className = _props.className,
          isError = _props.isError,
          launch = _props.launch,
          indicator = _props.indicator,
          footerLoadingText = _props.footerLoadingText,
          footerLoadedText = _props.footerLoadedText;
      var _launch$launchError = launch.launchError,
          launchError = _launch$launchError === undefined ? false : _launch$launchError,
          _launch$launchEmpty = launch.launchEmpty,
          launchEmpty = _launch$launchEmpty === undefined ? false : _launch$launchEmpty,
          _launch$launchFooterL = launch.launchFooterLoaded,
          launchFooterLoaded = _launch$launchFooterL === undefined ? false : _launch$launchFooterL,
          _launch$launchFooterL2 = launch.launchFooterLoading,
          launchFooterLoading = _launch$launchFooterL2 === undefined ? false : _launch$launchFooterL2;
      var _indicator$release = indicator.release,
          release = _indicator$release === undefined ? '加载中' : _indicator$release,
          _indicator$activate = indicator.activate,
          activate = _indicator$activate === undefined ? '下拉刷新' : _indicator$activate,
          _indicator$deactivate = indicator.deactivate,
          deactivate = _indicator$deactivate === undefined ? '释放刷新' : _indicator$deactivate;
      var _state = this.__state,
          canScrollY = _state.canScrollY,
          isInit = _state.isInit,
          blockStyle = _state.blockStyle,
          needPullDown = _state.needPullDown,
          downLoading = _state.downLoading,
          lowerLoading = _state.lowerLoading;


      var showTipText = !downLoading && needPullDown && !isInit; // 下拉文案
      var showTipFreedText = !downLoading && !needPullDown && !isInit; // 释放文案

      var showChildren = !(isEmpty || isError); // 展示children内容

      var showFooter = !isEmpty && !isError; // 空、错状态不展示底部
      var footerLoaded = showFooter && !launchFooterLoaded && !hasMore;
      var customFooterLoaded = showFooter && launchFooterLoaded && !hasMore; // 渲染renderLoadedText
      var footerLoading = showFooter && !launchFooterLoading && lowerLoading;
      var customFooterLoading = showFooter && launchFooterLoading && lowerLoading; // 渲染renderNoMore

      var showError = isError; // isErrorUI权重最高
      var showErrorText = showError && !launchError; // 渲染ErrorText
      var showRenderError = showError && launchError; // 渲染renderError
      var showEmpty = !isError && !downLoading && isEmpty; // isErrorUI权重最高
      var showEmptyText = showEmpty && !launchEmpty; // 渲染emptyText
      var showRenderEmpty = showEmpty && launchEmpty; // 渲染renderEmpty

      var anonymousState__temp = (0, _index.internal_inline_style)(style);
      var anonymousState__temp2 = (0, _index.internal_inline_style)({ minHeight: '100%' });

      this.anonymousFunc0 = function (e) {
        return _this3.touchEvent(e);
      };

      this.anonymousFunc1 = function (e) {
        return _this3.touchEvent(e);
      };

      this.anonymousFunc2 = function (e) {
        return _this3.touchEvent(e);
      };

      this.anonymousFunc3 = function (e) {
        return _this3.touchEvent(e);
      };

      var anonymousState__temp3 = (0, _index.internal_inline_style)(blockStyle);
      Object.assign(this.__state, {
        anonymousState__temp: anonymousState__temp,
        anonymousState__temp2: anonymousState__temp2,
        anonymousState__temp3: anonymousState__temp3,
        className: className,
        showTipFreedText: showTipFreedText,
        showTipText: showTipText,
        showChildren: showChildren,
        showErrorText: showErrorText,
        showRenderError: showRenderError,
        showEmptyText: showEmptyText,
        emptyImg: emptyImg,
        showRenderEmpty: showRenderEmpty,
        footerLoading: footerLoading,
        customFooterLoading: customFooterLoading,
        footerLoaded: footerLoaded,
        customFooterLoaded: customFooterLoaded,
        deactivate: deactivate,
        tipFreedText: tipFreedText,
        activate: activate,
        tipText: tipText,
        release: release,
        emptyText: emptyText,
        footerLoadingText: footerLoadingText,
        noMore: noMore,
        footerLoadedText: footerLoadedText
      });
      return this.__state;
    }
  }, {
    key: "anonymousFunc0",
    value: function anonymousFunc0(e) {
      ;
    }
  }, {
    key: "anonymousFunc1",
    value: function anonymousFunc1(e) {
      ;
    }
  }, {
    key: "anonymousFunc2",
    value: function anonymousFunc2(e) {
      ;
    }
  }, {
    key: "anonymousFunc3",
    value: function anonymousFunc3(e) {
      ;
    }
  }]);

  return ListView;
}(_index.Component), _class.$$events = ["handleScrollToLower", "onScroll", "anonymousFunc0", "anonymousFunc1", "anonymousFunc2", "anonymousFunc3", "fetchInit"], _class.options = {
  addGlobalClass: true
}, _class.defaultProps = {
  distanceToRefresh: 30,
  isEmpty: false,
  emptyText: '',
  noMore: '已经到底了~',
  footerLoadingText: '加载中...',
  footerLoadedText: '已经到底了~',
  scrollTop: 0,
  touchScrollTop: 0,
  onScrollToLower: function onScrollToLower() {},
  onPullDownRefresh: null,
  hasMore: false,
  needInit: false,
  isError: false,
  launch: {},
  renderEmpty: null,
  renderError: null,
  indicator: {}
}, _class.multipleSlots = true, _class.$$componentPath = "components/ListView/index", _temp2);
exports.default = ListView;

Component(require('../../npm/@tarojs/taro-weapp/index.js').default.createComponent(ListView));