"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
/**
 * NOTE HOST、HOST_M 是在 config 中通过 defineConstants 配置的
 * 只所以不在代码中直接引用，是因为 eslint 会报 no-undef 的错误，因此用如下方式处理
 */
/* eslint-disable */
var host = exports.host = "http://192.168.0.84:8080";
var wss_host = exports.wss_host = "ws://192.168.0.84:8080";

/* eslint-enable */

var pathname = exports.pathname = '/api/wx';

var resolvePath = function resolvePath(api) {
  return "http://192.168.0.84:8080/api/wx" + "/" + api;
};

// common
var API_QRCODE = exports.API_QRCODE = resolvePath('qrcode');
var API_BANNER_LIST = exports.API_BANNER_LIST = resolvePath('extendContent');
var API_QUERY_CODE_SCENE = exports.API_QUERY_CODE_SCENE = resolvePath('qrcode/scene');

// user
var API_USER_LOGIN = exports.API_USER_LOGIN = resolvePath('login');
var API_USER_INFO = exports.API_USER_INFO = resolvePath('signup');
var API_USER_SIGNIN = exports.API_USER_SIGNIN = resolvePath('user/signin');
var API_USER_PHONE = exports.API_USER_PHONE = resolvePath('userPhone');
var API_QUERY_USER_INFO = exports.API_QUERY_USER_INFO = resolvePath('user/info');
var API_QUERY_USERINFO_BYID = exports.API_QUERY_USERINFO_BYID = resolvePath('onePerson');
var API_QUERY_CUSTOMER_INFO = exports.API_QUERY_CUSTOMER_INFO = resolvePath('customer/myCustomer');
var API_QUERY_MYREPORT = exports.API_QUERY_MYREPORT = resolvePath('customer/myReport');

// chat
var API_CHAT_HISTORY = exports.API_CHAT_HISTORY = resolvePath('chat/history');
var API_CHAT_SEND = exports.API_CHAT_SEND = "ws://192.168.0.84:8080/wx/chat";
var API_CHAT_FRIENDS = exports.API_CHAT_FRIENDS = resolvePath('chat/with');
var API_UPLOAD_IMAGE = exports.API_UPLOAD_IMAGE = resolvePath('image');

// card
var API_CARDS_LIST = exports.API_CARDS_LIST = resolvePath('cards');
var API_CARDS_APPLY = exports.API_CARDS_APPLY = resolvePath('cards/apply');
var API_FORM_ID = exports.API_FORM_ID = resolvePath('formid');

// project
var API_ITEMS_LIST = exports.API_ITEMS_LIST = resolvePath('building/list');
var API_ITEMS_DETAIL = exports.API_ITEMS_DETAIL = resolvePath('buildingSelectId');
var API_ITEMS_TYPE = exports.API_ITEMS_TYPE = resolvePath('tdBuildingType');

// shop
var API_GOODS_LIST = exports.API_GOODS_LIST = resolvePath('goods');
var API_GOODS_EXCHANGE = exports.API_GOODS_EXCHANGE = resolvePath('goods/exchange');
var API_GOODS_EXCHANGE_RECORDS = exports.API_GOODS_EXCHANGE_RECORDS = resolvePath('taPointsExchange');
var API_POINTS_RECORDS = exports.API_POINTS_RECORDS = resolvePath('taPointsRecords');
var API_POINTS_RULE = exports.API_POINTS_RULE = resolvePath('tdPointsRules');
var API_POINTS_ADRESS = exports.API_POINTS_ADRESS = resolvePath('person/city');

// client
var API_CLIENT_LIST = exports.API_CLIENT_LIST = resolvePath('customer/recommend/mine');
var API_RECOMENT_CLIENT = exports.API_RECOMENT_CLIENT = resolvePath('customer/new');
var API_CLIENT_PROGRESS = exports.API_CLIENT_PROGRESS = resolvePath('customer');
var API_TYPE_DATA = exports.API_TYPE_DATA = resolvePath('awesome/dict/recommendcustomer');

// report
var API_REPORT_LIST = exports.API_REPORT_LIST = resolvePath('myReport');
var API_REPORT_CLIENT = exports.API_REPORT_CLIENT = resolvePath('customer/report');
var API_RECOMMEND_GET = exports.API_RECOMMEND_GET = resolvePath('customer/recommend/get');
var API_RECOMMEND_EDIT = exports.API_RECOMMEND_EDIT = resolvePath('customer/recommend/edit');

// common
var API_ITEMS_UV = exports.API_ITEMS_UV = resolvePath('project/hot');
var API_CARDS_UV = exports.API_CARDS_UV = resolvePath('consultant/hot');
var API_ACTIVITY_UV = exports.API_ACTIVITY_UV = resolvePath('activity/pvNum');
var API_NEWS_UV = exports.API_NEWS_UV = resolvePath('taNews/pvNum');

var API_CARDS_LIKE = exports.API_CARDS_LIKE = resolvePath('consultant/like');
var API_ITEMS_LIKE = exports.API_ITEMS_LIKE = resolvePath('project/like');
var API_ACTIVITY_LIKE = exports.API_ACTIVITY_LIKE = resolvePath('activity/like');
var API_NEWS_LIKE = exports.API_NEWS_LIKE = resolvePath('news/like');

var API_CARDS_SHARE = exports.API_CARDS_SHARE = resolvePath('consultant/share');
var API_ITEMS_SHARE = exports.API_ITEMS_SHARE = resolvePath('project/share');
var API_ACTIVITY_SHARE = exports.API_ACTIVITY_SHARE = resolvePath('activity/share');
var API_NEWS_SHARE = exports.API_NEWS_SHARE = resolvePath('news/share');

var API_ACTIVITY_FAVOR = exports.API_ACTIVITY_FAVOR = resolvePath('activity/save');
var API_NEWS_FAVOR = exports.API_NEWS_FAVOR = resolvePath('news/save');
var API_CARD_FAVOR = exports.API_CARD_FAVOR = resolvePath('card/save');
var API_PROJECT_FAVOR = exports.API_PROJECT_FAVOR = resolvePath('project/save');

// 埋点接口
var API_BURIED_POINT = exports.API_BURIED_POINT = resolvePath('taPersonVisitRecord');

// activity
var API_ACTIVITY_LIST = exports.API_ACTIVITY_LIST = resolvePath('buildingDynamiceList');
//拼团
var API_GROUP_LIST = exports.API_GROUP_LIST = resolvePath('taShareRecord');
//助力
var API_HELP_LIST = exports.API_HELP_LIST = resolvePath('helpInitiateRecord');

// save activity
var API_ACTIVITY_SAVE = exports.API_ACTIVITY_SAVE = resolvePath('save/buildingDynamiceList');

var API_ACTIVITY_DETAIL = exports.API_ACTIVITY_DETAIL = resolvePath('buildingDynamiceInfo');
// signup
var API_ACTIVITY_SIGNUP = exports.API_ACTIVITY_SIGNUP = resolvePath('activityDynamicEnlistAdd');
// signin
var API_ACTIVITY_SIGNIN = exports.API_ACTIVITY_SIGNIN = resolvePath('taCheckin/activity');

// news
var API_NEWS_LIST = exports.API_NEWS_LIST = resolvePath('taNews');

// feedback
var API_FEEDBACK_SUBMIT = exports.API_FEEDBACK_SUBMIT = resolvePath('taCustomerMessage');

// getCode
var API_GET_CODE = exports.API_GET_CODE = resolvePath('captcha');

// registerConsultant
var API_PUT_REGISTER = exports.API_PUT_REGISTER = resolvePath('registerConsultant');

// city
var API_CITY_LIST = exports.API_CITY_LIST = resolvePath('tdCity');

// policy
var API_POLICY_LIST = exports.API_POLICY_LIST = resolvePath('taPolicy');

//agent

var API_AGENT_LIST = exports.API_AGENT_LIST = resolvePath('agent/recommend/mine');

var API_REGISTER_AGENT = exports.API_REGISTER_AGENT = resolvePath('registerAgent');

// agent change
var API_AGENT_CHANNEL = exports.API_AGENT_CHANNEL = resolvePath('customer/recommend/becomeChannel');

var API_AGENT_CURRENT = exports.API_AGENT_CURRENT = resolvePath('user/current');

var API_EDIT_AGENT = exports.API_EDIT_AGENT = resolvePath('editPerson');

// 活动列表-新
var API_ACTNEW_LIST = exports.API_ACTNEW_LIST = resolvePath('activity/list');

// 助力
var API_HELP_DETAIL = exports.API_HELP_DETAIL = resolvePath('helpActivity');
var API_HELP_CREATE = exports.API_HELP_CREATE = resolvePath('helpInitiateRecord');
var API_HELP_FRIEND = exports.API_HELP_FRIEND = resolvePath('helpRecord');

//