"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _class, _temp2;

var _index = require("../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * 文档参考
 * http://taro-ext.jd.com/plugin/view/5d23051670a0f46a87c9785b
 */
var Index = (_temp2 = _class = function (_BaseComponent) {
  _inherits(Index, _BaseComponent);

  function Index() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Index);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Index.__proto__ || Object.getPrototypeOf(Index)).call.apply(_ref, [this].concat(args))), _this), _this.$usedState = ["$compid__53", "shareImage", "canvasStatus", "config", "visible", "basicConfig", "data", "toggle"], _this.state = {
      // 绘制的图片
      shareImage: null,
      canvasStatus: false,
      config: null,
      visible: false,
      basicConfig: {
        width: 640,
        height: 1136,
        backgroundColor: '#2F3957',
        debug: false
      }
    }, _this.onCreateSuccess = function (result) {
      var tempFilePath = result.tempFilePath,
          errMsg = result.errMsg;

      _index2.default.hideLoading();
      if (errMsg === 'canvasToTempFilePath:ok') {
        _this.setState({
          shareImage: tempFilePath,
          canvasStatus: false,
          config: null,
          visible: true
        });
      } else {
        _this.setState({
          canvasStatus: false,
          config: null
        });
        _index2.default.showToast({ icon: 'none', title: errMsg || '出现错误' });
        console.log(errMsg);
        _this.hidePoster();
      }
    }, _this.onCreateFail = function (error) {
      console.log(error);
    }, _this.saveToAlbum = function (e) {
      e.stopPropagation();
      e.preventDefault();

      _index2.default.authorize({ scope: "scope.writePhotosAlbum" }).then(function (res) {
        console.log('auth:', res);
        _index2.default.saveImageToPhotosAlbum({
          filePath: _this.state.shareImage
        }).then(function (res) {
          _index2.default.showToast({
            title: '保存图片成功',
            icon: 'success',
            duration: 2000
          });
        });
      }).catch(function (err) {
        console.log('err:', err);
        _index2.default.showToast({
          title: '未开启相册权限',
          icon: 'none'
        });
      });
    }, _this.customComponents = ["TaroCanvasDrawer"], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Index, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(Index.prototype.__proto__ || Object.getPrototypeOf(Index.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.initConfig();
      _index2.default.showLoading({
        title: '海报生成中...'
      });
    }
  }, {
    key: "initConfig",
    value: function initConfig() {
      var data = this.props.data;
      var basicConfig = this.state.basicConfig;

      var texts = [{
        x: 70,
        y: 150,
        text: "" + data.name,
        fontSize: 38,
        color: 'black',
        baseLine: 'middle',
        lineHeight: 48,
        width: 260,
        zIndex: 999
      }, {
        x: 70,
        y: 210,
        text: "" + data.company,
        fontSize: 30,
        color: '#999',
        baseLine: 'middle',
        lineHeight: 48,
        width: 260,
        zIndex: 999
      }, {
        x: 110,
        y: 260,
        text: "" + data.phone,
        fontSize: 28,
        color: '#999',
        baseLine: 'middle',
        lineHeight: 48,
        width: 260,
        zIndex: 999
      }, {
        x: 120,
        y: 470,
        text: "\u91D1\u724C\u7F6E\u4E1A\u987E\u95EE",
        fontSize: 32,
        color: '#000',
        baseLine: 'middle',
        lineHeight: 48,
        width: 260,
        zIndex: 999
      }, {
        x: 70,
        y: 540,
        text: "\u597D\u8BC4\u7ECF\u7EAA\u4EBA\uFF0C\u719F\u6089\u697C\u76D8\u7279\u8272\uFF0C\u5F88\u6709\u8010\u5FC3\uFF0C\u975E\u5E38\u4E13\u4E1A\u6709\u7D20\u517B...",
        fontSize: 30,
        color: '#666',
        baseLine: 'middle',
        lineNum: 2,
        lineHeight: 48,
        // textAlign: 'center',
        width: 500,
        zIndex: 999
      }, {
        x: 100,
        y: 710,
        text: '长按识别小程序码',
        fontSize: 26,
        color: '#999',
        baseLine: 'middle',
        lineHeight: 48,
        width: 200,
        zIndex: 100
      }, {
        x: 100,
        y: 750,
        text: '进入',
        fontSize: 26,
        color: '#999',
        baseLine: 'middle',
        lineHeight: 48,
        width: 50,
        zIndex: 100
      }, {
        x: 160,
        y: 750,
        text: '橙蕉',
        fontSize: 28,
        color: 'black',
        baseLine: 'middle',
        lineHeight: 48,
        width: 120,
        zIndex: 100
      }, {
        x: 300,
        y: 750,
        text: '查看主页',
        fontSize: 26,
        color: '#999',
        baseLine: 'middle',
        lineHeight: 48,
        width: 150,
        zIndex: 100
      }, {
        x: 320,
        y: 1075,
        text: '橙蕉',
        fontSize: 32,
        color: '#b5b3b3',
        baseLine: 'middle',
        lineHeight: 48,
        width: 640,
        zIndex: 99,
        textAlign: 'center'
      }];
      var blocks = [{
        width: 600,
        height: 930,
        x: 20,
        y: 80,
        backgroundColor: '#fff',
        borderRadius: 40
      }, {
        width: 520,
        height: 160,
        x: 60,
        y: 650,
        backgroundColor: '#F8F8F8',
        borderRadius: 10,
        zIndex: 99
      }];
      var images = [{
        url: "/assets/person/jinpai.png",
        width: 42,
        height: 48,
        y: 440,
        x: 70,
        zIndex: 99
      }, {
        url: "/assets/person/tel2.png",
        width: 30,
        height: 30,
        y: 240,
        x: 70,
        zIndex: 99
      }, {
        url: "/assets/person/bottom.png",
        width: 600,
        height: 150,
        y: 870,
        x: 20,
        zIndex: 99,
        borderRadius: 40
      }, {
        url: data.picture,
        width: 210,
        height: 300,
        y: 40,
        x: 380,
        borderWidth: 15,
        borderColor: '#f1efef',
        borderRadius: 60,
        zIndex: 99
      }, {
        url: data.qrcode,
        width: 120,
        height: 120,
        y: 670,
        x: 430,
        zIndex: 100
      }];
      var config = Object.assign(basicConfig, { blocks: blocks, images: images, texts: texts });
      this.setState({
        config: config,
        canvasStatus: true
      });
    }
  }, {
    key: "onPreview",
    value: function onPreview(e) {
      e.stopPropagation();
      e.preventDefault();
      _index2.default.previewImage({
        current: this.state.shareImage,
        urls: [this.state.shareImage]
      });
    }
  }, {
    key: "hidePoster",
    value: function hidePoster(e) {
      _index2.default.hideLoading();
      this.props.toggle(false);
    }

    // 保存图片至本地

  }, {
    key: "_createData",
    value: function _createData() {
      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;
      var $compid__53 = (0, _index.genCompid)(__prefix + "$compid__53");
      this.__state.canvasStatus && _index.propsManager.set({
        "config": this.__state.config,
        "onCreateSuccess": this.onCreateSuccess,
        "onCreateFail": this.onCreateFail
      }, $compid__53);
      Object.assign(this.__state, {
        $compid__53: $compid__53
      });
      return this.__state;
    }
  }]);

  return Index;
}(_index.Component), _class.$$events = ["hidePoster", "onPreview", "saveToAlbum"], _class.options = {
  addGlobalClass: true
}, _class.defaultProps = {
  data: {}
}, _class.$$componentPath = "pages/card/poster", _temp2);
exports.default = Index;

Component(require('../../npm/@tarojs/taro-weapp/index.js').default.createComponent(Index));