"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _class, _temp2;

var _index = require("../../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _tools = require("../../../utils/tools.js");

var _feedBack = require("../../../services/feedBack.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FeedBack = (_temp2 = _class = function (_BaseComponent) {
  _inherits(FeedBack, _BaseComponent);

  function FeedBack() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, FeedBack);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FeedBack.__proto__ || Object.getPrototypeOf(FeedBack)).call.apply(_ref, [this].concat(args))), _this), _this.$usedState = ["message", "phone", "files", "loading"], _this.state = {
      phone: '',
      message: '',
      files: [],
      loading: false
    }, _this.config = {
      navigationBarTitleText: '意见反馈'
    }, _this.handleSubmit = function (e) {
      var formId = e.detail.formId;
      var _this$state = _this.state,
          message = _this$state.message,
          phone = _this$state.phone,
          files = _this$state.files;

      var payload = {
        formId: formId,
        message: message,
        phone: phone,
        files: files.map(function (file) {
          return file.url;
        })
      };
      if (_this.validate(payload)) {
        (0, _feedBack.submitFeedBack)(payload).then(function (res) {
          _index2.default.showToast({
            title: '意见提交成功',
            icon: 'success',
            duration: 2000
          });

          setTimeout(function () {
            _index2.default.navigateBack({ delta: 1 });
          }, 1000);
        });
      }
    }, _this.customComponents = [], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(FeedBack, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(FeedBack.prototype.__proto__ || Object.getPrototypeOf(FeedBack.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "validate",
    value: function validate(value) {
      var message = value.message,
          phone = value.phone;

      if (!message) {
        _index2.default.showToast({
          title: '问题描述不能为空',
          icon: 'none'
        });
        return false;
      }

      if (phone && !(0, _tools.isChineseMobilePhoneNumber)(phone) && !(0, _tools.isEmail)(phone)) {
        _index2.default.showToast({
          title: '联系方式输入格式错误',
          icon: 'none'
        });
        return false;
      }
      return true;
    }
  }, {
    key: "onImagePickerChange",
    value: function onImagePickerChange(files) {
      this.setState({
        files: files
      });
    }
  }, {
    key: "onTextareaChange",
    value: function onTextareaChange(e) {
      this.setState({
        message: e.target.value
      });
    }
  }, {
    key: "onContactChange",
    value: function onContactChange(e) {
      this.setState({
        phone: e.target.value
      });
    }
  }, {
    key: "_createData",
    value: function _createData() {
      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;
      Object.assign(this.__state, {});
      return this.__state;
    }
  }]);

  return FeedBack;
}(_index.Component), _class.$$events = ["handleSubmit", "onTextareaChange", "onContactChange"], _class.$$componentPath = "pages/person/feedback/index", _temp2);
exports.default = FeedBack;

Component(require('../../../npm/@tarojs/taro-weapp/index.js').default.createComponent(FeedBack, true));