"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _dec, _class, _class2, _temp2;

var _index = require("../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _user = require("../../constants/user.js");

var _user2 = require("../../services/user.js");

var _index3 = require("../../npm/@tarojs/redux/index.js");

var _user3 = require("../../actions/user.js");

var actions = _interopRequireWildcard(_user3);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Person = (_dec = (0, _index3.connect)(function (_ref) {
  var user = _ref.user,
      city = _ref.city;
  return { user: user, city: city };
}, _extends({}, actions)), _dec(_class = (_temp2 = _class2 = function (_BaseComponent) {
  _inherits(Person, _BaseComponent);

  function Person() {
    var _ref2;

    var _temp, _this, _ret;

    _classCallCheck(this, Person);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref2 = Person.__proto__ || Object.getPrototypeOf(Person)).call.apply(_ref2, [this].concat(args))), _this), _this.$usedState = ["phone", "anonymousState__temp8", "anonymousState__temp9", "isLogin", "user", "isAgent", "consultant", "tourist"], _this.config = {
      navigationBarTitleText: '我的'
    }, _this.state = {
      isLogin: false,
      user: {},
      isAgent: false, //经纪人
      consultant: false, //置业顾问
      tourist: false //普通用户
    }, _this.customComponents = ["Authorize", "Notice"], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Person, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(Person.prototype.__proto__ || Object.getPrototypeOf(Person.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentDidShow",
    value: function componentDidShow() {
      _index2.default.showLoading();
      this.loadUserInfo();
      _index2.default.hideLoading();
    }
  }, {
    key: "loadUserInfo",
    value: function loadUserInfo() {
      var _this2 = this;

      (0, _user2.queryUserInfo)().then(function (user) {
        _this2.setState({
          user: user,
          phone: user.phone
        }, function () {
          if (user.personType != _user.ROLE_CODE['CHANNEL_AGENT'] && user.personType != _user.ROLE_CODE['ESTATE_AGENT'] && user.personType != 'Realty Consultant') {
            _this2.setState({ tourist: true, phone: user.phone });
          }
        });
      });
    }
  }, {
    key: "doSign",
    value: function doSign() {
      var _this3 = this;

      var _state$user = this.state.user,
          id = _state$user.id,
          havaSigned = _state$user.havaSigned;

      if (havaSigned) {
        _index2.default.showToast({
          title: '你已经签到过了',
          icon: 'none'
        });
        return;
      }

      (0, _user2.doUserSignin)({ id: id }).then(function (res) {
        _index2.default.showToast({
          title: '签到成功'
        });

        _this3.loadUserInfo();

        // App.zhuge.track('签到成功')
      });
    }
  }, {
    key: "toHomePage",
    value: function toHomePage() {
      _index2.default.switchTab({
        url: '/pages/project/index'
      });
    }
  }, {
    key: "toShopPage",
    value: function toShopPage() {
      _index2.default.switchTab({
        url: '/pages/shop/index'
      });
    }
  }, {
    key: "toClientPage",
    value: function toClientPage() {
      var customerNum = this.state.user.customerNum;


      if (customerNum <= 0) {
        _index2.default.showToast({ title: '暂无客户', icon: 'none' });
        return;
      }
      // App.zhuge.track('推荐客户')

      _index2.default.navigateTo({
        url: '/pages/person/myGuest/index'
      });
    }
  }, {
    key: "toFavor",
    value: function toFavor() {
      _index2.default.navigateTo({
        url: '/pages/person/favorite/index'
      });
    }
  }, {
    key: "toAssemble",
    value: function toAssemble() {
      _index2.default.navigateTo({
        url: '/pages/activity/assemblePage'
      });
    }
  }, {
    key: "toAssistance",
    value: function toAssistance() {
      _index2.default.navigateTo({
        url: '/pages/activity/assistancePage'
      });
    }
  }, {
    key: "getRoleName",
    value: function getRoleName(type) {
      switch (type) {
        case _user.ROLE_CODE['CONSULTANT']:
          this.setState({ consultant: true });
          return '置业顾问';
          break;
        case _user.ROLE_CODE['ESTATE_AGENT']:
          this.setState({ isAgent: true });
          return '独立经纪人';
          break;
        case _user.ROLE_CODE['CHANNEL_AGENT']:
          this.setState({ isAgent: true });
          return '渠道经纪人';
          break;
        default:

          return '普通用户';
          break;
      }
    }
  }, {
    key: "goShop",
    value: function goShop() {
      _index2.default.switchTab({
        url: "/pages/shop/index"
      });
    }
  }, {
    key: "handleMore",
    value: function handleMore() {
      _index2.default.showModal({
        title: '温馨提示',
        content: '敬请期待'
      });
    }
  }, {
    key: "goPersonDetail",
    value: function goPersonDetail() {
      var personType = this.state.user.personType;

      if (personType == _user.ROLE_CODE['CHANNEL_AGENT'] || personType == _user.ROLE_CODE['ESTATE_AGENT']) {
        _index2.default.navigateTo({
          url: '/pages/person/personDetail/index'
        });
      }
    }
  }, {
    key: "_createLoginData",
    value: function _createLoginData(_$uid) {
      return function () {
        return {};
      };
    }
  }, {
    key: "_createDetailData",
    value: function _createDetailData(_$uid) {
      var _this4 = this;

      return function () {
        var _state = _this4.state,
            user = _state.user,
            isAgent = _state.isAgent,
            consultant = _state.consultant,
            tourist = _state.tourist;
        // const isConsultant = user.personType == ROLE_CODE['CONSULTANT']
        // const isConsultant = user.personType

        var anonymousState__temp = "/assets/mine/background.png";
        var anonymousState__temp2 = _this4.getRoleName(user.personType);
        var anonymousState__temp3 = "/assets/mine/tuiguangma.png";
        var anonymousState__temp4 = "/assets/mine/homepage.png";
        var anonymousState__temp5 = "/assets/mine/homepage.png";
        var anonymousState__temp6 = "/assets/mine/regiment.png";
        var anonymousState__temp7 = "/assets/mine/help.png";
        return {
          anonymousState__temp: anonymousState__temp,
          anonymousState__temp2: anonymousState__temp2,
          anonymousState__temp3: anonymousState__temp3,
          anonymousState__temp4: anonymousState__temp4,
          anonymousState__temp5: anonymousState__temp5,
          anonymousState__temp6: anonymousState__temp6,
          anonymousState__temp7: anonymousState__temp7,
          user: user
        };
      };
    }
  }, {
    key: "_createData",
    value: function _createData() {
      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;

      var phone = this.__state.user.phone;

      var anonymousState__temp8 = phone ? this._createDetailData(__prefix + "QBKcrTEkUt")() : null;
      var anonymousState__temp9 = !phone ? this._createLoginData(__prefix + "LkfQWCLxMX")() : null;
      Object.assign(this.__state, {
        phone: phone,
        anonymousState__temp8: anonymousState__temp8,
        anonymousState__temp9: anonymousState__temp9
      });
      return this.__state;
    }
  }]);

  return Person;
}(_index.Component), _class2.$$events = ["goPersonDetail", "doSign", "toAssemble", "toAssistance"], _class2.$$componentPath = "pages/person/index", _temp2)) || _class);
exports.default = Person;

Component(require('../../npm/@tarojs/taro-weapp/index.js').default.createComponent(Person, true));