"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _class, _temp2;

var _index = require("../../../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * 文档参考
 * http://taro-ext.jd.com/plugin/view/5d23051670a0f46a87c9785b
 */
var Index = (_temp2 = _class = function (_BaseComponent) {
  _inherits(Index, _BaseComponent);

  function Index() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Index);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Index.__proto__ || Object.getPrototypeOf(Index)).call.apply(_ref, [this].concat(args))), _this), _this.$usedState = ["$compid__52", "shareImage", "canvasStatus", "config", "basicConfig", "data"], _this.state = {
      // 绘制的图片
      shareImage: null,
      canvasStatus: false,
      config: null,
      basicConfig: {
        width: 500,
        height: 530,
        backgroundColor: '#fff',
        debug: false
      }
    }, _this.onCreateSuccess = function (result) {
      var tempFilePath = result.tempFilePath,
          errMsg = result.errMsg;

      _index2.default.hideLoading();
      if (errMsg === 'canvasToTempFilePath:ok') {

        _this.setState({
          shareImage: tempFilePath,
          // 重置 TaroCanvasDrawer 状态，方便下一次调用
          canvasStatus: false,
          config: null
        });
        _index2.default.saveImageToPhotosAlbum({
          filePath: tempFilePath,
          success: function success(res) {
            _index2.default.showToast({
              title: '已保存到相册',
              icon: 'success',
              duration: 2000
            });
          }, fail: function fail() {
            _index2.default.showToast({
              title: '保存失败',
              icon: 'success',
              duration: 2000
            });
          }
        });
      } else {
        // 重置 TaroCanvasDrawer 状态，方便下一次调用
        _this.setState({
          canvasStatus: false,
          config: null
        });

        _index2.default.showToast({ icon: 'none', title: errMsg || '出现错误' });
        console.log(errMsg);
      }

      // 预览
      // Taro.previewImage({
      //   current: tempFilePath,
      //   urls: [tempFilePath]
      // })
    }, _this.onCreateFail = function (error) {
      _index2.default.hideLoading();
      console.log(error);
    }, _this.saveToAlbum = function () {
      var res = _index2.default.saveImageToPhotosAlbum({
        filePath: _this.state.shareImage
      });
      if (res.errMsg === 'saveImageToPhotosAlbum:ok') {
        _index2.default.showToast({
          title: '保存图片成功',
          icon: 'success',
          duration: 2000
        });
      }
    }, _this.customComponents = ["TaroCanvasDrawer"], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Index, [{
    key: "_constructor",
    value: function _constructor(props) {
      _get(Index.prototype.__proto__ || Object.getPrototypeOf(Index.prototype), "_constructor", this).call(this, props);

      this.$$refs = [];
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.initConfig();
      _index2.default.showLoading({
        title: '海报生成中...'
      });
    }
  }, {
    key: "initConfig",
    value: function initConfig() {
      var data = this.props.data;
      var basicConfig = this.state.basicConfig;

      var texts = [{
        x: 120,
        y: 90,
        text: data.nickname,
        fontSize: 28,
        color: '#000',
        baseLine: 'middle',
        lineHeight: 48,
        width: 200
      }, {
        x: 250,
        y: 580,
        text: data.tip,
        fontSize: 20,
        color: '#999999',
        baseLine: 'middle',
        lineHeight: 48,
        width: 500,
        textAlign: 'center'
      }];
      var images = [{
        url: data.avatarurl || "/assets/default-avatar.png",
        width: 90,
        height: 90,
        y: 30,
        x: 20,
        borderWidth: 1,
        borderRadius: 20
      }, {
        url: data.qrcode,
        width: 400,
        height: 400,
        y: 130,
        x: 50
      }];
      var blocks = [{
        x: 300,
        y: 100,
        color: '#fff',
        baseLine: 'middle',
        lineHeight: 48,
        width: 500,
        height: 530
      }];
      var config = Object.assign(basicConfig, { images: images, texts: texts, blocks: blocks });
      this.setState({
        config: config,
        canvasStatus: true
      });
    }

    // 保存图片至本地

  }, {
    key: "_createData",
    value: function _createData() {
      this.__state = arguments[0] || this.state || {};
      this.__props = arguments[1] || this.props || {};
      var __isRunloopRef = arguments[2];
      var __prefix = this.$prefix;
      ;
      var $compid__52 = (0, _index.genCompid)(__prefix + "$compid__52");
      this.__state.canvasStatus && _index.propsManager.set({
        "config": this.__state.config,
        "onCreateSuccess": this.onCreateSuccess,
        "onCreateFail": this.onCreateFail
      }, $compid__52);
      Object.assign(this.__state, {
        $compid__52: $compid__52
      });
      return this.__state;
    }
  }]);

  return Index;
}(_index.Component), _class.$$events = [], _class.defaultProps = {
  data: {}
}, _class.$$componentPath = "pages/person/spread/poster", _temp2);
exports.default = Index;

Component(require('../../../npm/@tarojs/taro-weapp/index.js').default.createComponent(Index));