"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = card;

var _card = require("../constants/card.js");

var INITIAL_STATE = {
  cardList: [],
  cardInfo: {}
};

function card() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : INITIAL_STATE;
  var action = arguments[1];

  switch (action.type) {
    case _card.CARD_INFO:
      {
        return _extends({}, state, {
          cardInfo: _extends({}, action.payload)
        });
      }
    case _card.CARD_LIKE:
      {
        return _extends({}, state, {
          cardInfo: _extends({}, state.cardInfo, {
            liked: true,
            likeNum: state.cardInfo.likeNum + 1
          })
        });
      }
    case _card.CARD_UNLIKE:
      {
        return _extends({}, state, {
          cardInfo: _extends({}, state.cardInfo, {
            liked: false,
            likeNum: state.cardInfo.likeNum - 1
          })
        });
      }
    case _card.CARD_LIST:
      {
        return _extends({}, state, {
          cardList: _extends({}, action.payload.records || [])
        });
      }

    default:
      return state;
  }
}