"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = user;

var _user = require("../constants/user.js");

var INITIAL_STATE = {
  userInfo: {
    person: {},
    extraInfo: {}
  },
  unReadNum: 0
};

function user() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : INITIAL_STATE;
  var action = arguments[1];

  switch (action.type) {
    case _user.USER_INFO:
      {
        return _extends({}, state, {
          userInfo: _extends({}, action.payload)
        });
      }
    // case USER_QUERY_INFO: {
    //   const { person } = state.userInfo
    //   return {
    //     ...state,
    //     userInfo: {
    //       person,
    //       extraInfo: {
    //         ...action.payload
    //       }

    //     }
    //   }
    // }
    case _user.UPDATE_USER_INFO:
      {
        var _state$userInfo = state.userInfo,
            person = _state$userInfo.person,
            extraInfo = _state$userInfo.extraInfo;

        debugger;
        return _extends({}, state, {
          userInfo: {
            extraInfo: extraInfo,
            person: _extends({}, person, action.payload)
          }
        });
      }
    case _user.USER_SIGNIN:
      {
        var _state$userInfo2 = state.userInfo,
            _person = _state$userInfo2.person,
            _extraInfo = _state$userInfo2.extraInfo;

        return _extends({}, state, {
          userInfo: {
            person: _extends({}, _person, {
              points: _person.points + 1
            }),
            extraInfo: _extends({}, _extraInfo, {
              havaSigned: 1
            })
          }
        });
      }
    case _user.ASSIGN_UNREADNUM:
      {
        var unReadNum = action.payload.unReadNum;

        return _extends({}, state, {
          unReadNum: unReadNum
        });
      }
    case _user.INCREASE_UNREADNUM:
      {
        var _unReadNum = state.unReadNum;

        return _extends({}, state, {
          unReadNum: _unReadNum + 1
        });
      }
    case _user.DECREASE_UNREADNUM:
      {
        return _extends({}, state, {
          unReadNum: 0
        });
      }
    default:
      return state;
  }
}