"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.giveFriendHelp = exports.createHelpActivity = exports.getHelpDetail = exports.getActNewList = exports.cancelFavorActivity = exports.favorActivity = exports.signupActivity = exports.queryActivityDetail = exports.buildingDynamiceList = exports.queryHelpList = exports.queryGroupList = exports.queryActivityList = exports.addActivityShareNum = exports.addActivityUv = undefined;

var _request = require("../utils/request.js");

var _api = require("../constants/api.js");

/**
 * 项目uv埋点
 * @param {*} id  项目id
 */
var addActivityUv = exports.addActivityUv = function addActivityUv(id) {
  return (0, _request.fetch)({ url: _api.API_ACTIVITY_UV + "/" + id, method: 'POST' });
};

/**
 * 项目分享埋点
 * @param {*} id  名片id
 */
var addActivityShareNum = exports.addActivityShareNum = function addActivityShareNum(id) {
  return (0, _request.fetch)({ url: _api.API_ACTIVITY_SHARE + "/" + id, method: 'POST' });
};

/**
 * 获取活动列表
 * @param {*} payload
 */
var queryActivityList = exports.queryActivityList = function queryActivityList(payload) {
  return (0, _request.fetch)({ url: _api.API_ACTIVITY_LIST, payload: payload });
};
/**
 * 获取拼团列表
 * @param {*} payload
 */
var queryGroupList = exports.queryGroupList = function queryGroupList(payload) {
  return (0, _request.fetch)({ url: _api.API_GROUP_LIST, payload: payload });
};
/**
 * 获取助力列表
 * @param {*} payload
 */
var queryHelpList = exports.queryHelpList = function queryHelpList(payload) {
  return (0, _request.fetch)({ url: _api.API_HELP_LIST, payload: payload });
};

/**
 * 已收藏活动列表
 * @param {*} payload
 */
var buildingDynamiceList = exports.buildingDynamiceList = function buildingDynamiceList(payload) {
  return (0, _request.fetch)({ url: _api.API_ACTIVITY_SAVE, payload: payload });
};

/**
 * 获取活动详情 
 * @param {*} id
 */
var queryActivityDetail = exports.queryActivityDetail = function queryActivityDetail(id) {
  return (0, _request.fetch)({ url: _api.API_ACTIVITY_DETAIL + "/" + id });
};

/**
 * 活动报名
 * @param {*} payload 
 */
var signupActivity = exports.signupActivity = function signupActivity(payload) {
  return (0, _request.fetch)({ url: _api.API_ACTIVITY_SIGNUP, payload: payload, method: 'POST' });
};

/**
 * 活动收藏
 * @param {*} payload 
 */
var favorActivity = exports.favorActivity = function favorActivity(id) {
  return (0, _request.fetch)({ url: _api.API_ACTIVITY_FAVOR + "/" + id, method: 'POST' });
};

/**
 * 取消活动收藏
 * @param {*} payload 
 */
var cancelFavorActivity = exports.cancelFavorActivity = function cancelFavorActivity(id) {
  return (0, _request.fetch)({ url: _api.API_ACTIVITY_FAVOR + "/" + id, method: 'DELETE' });
};

/**
 * 获取活动列表
 * @param {*} payload 
 */
var getActNewList = exports.getActNewList = function getActNewList(payload) {
  return (0, _request.fetch)({ url: _api.API_ACTNEW_LIST, payload: payload });
};

var getHelpDetail = exports.getHelpDetail = function getHelpDetail(id, initiateId) {
  return (0, _request.fetch)({ url: _api.API_HELP_DETAIL + "/" + id + (initiateId ? '?initiateId=' + initiateId : ''), method: 'GET' });
};
var createHelpActivity = exports.createHelpActivity = function createHelpActivity(payload) {
  return (0, _request.fetch)({ url: _api.API_HELP_CREATE, method: 'POST', payload: payload });
};
var giveFriendHelp = exports.giveFriendHelp = function giveFriendHelp(payload) {
  return (0, _request.fetch)({ url: _api.API_HELP_FRIEND, method: 'POST', payload: payload });
};