"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.editAgent = exports.agentCurrent = exports.becomeChannel = exports.registerAgent = exports.getAgentList = undefined;

var _request = require("../utils/request.js");

var _api = require("../constants/api.js");

/**
 * 推荐经纪人列表
 * @param {*} payload
 */
var getAgentList = exports.getAgentList = function getAgentList(payload) {
  return (0, _request.fetch)({ url: _api.API_AGENT_LIST, payload: payload });
};

/**
 * 成为经纪人
 * @param {*} payload
 */
var registerAgent = exports.registerAgent = function registerAgent(payload) {
  return (0, _request.fetch)({ url: _api.API_REGISTER_AGENT + "?recommendAgentCode=" + payload.recommendAgentCode + "&&channelCode=" + payload.channelCode, method: 'PUT' });
};

/**
 * 变更经纪人类型 
 * @param {*} payload
 */
var becomeChannel = exports.becomeChannel = function becomeChannel(payload) {
  return (0, _request.fetch)({ url: _api.API_AGENT_CHANNEL + "?channelCode=" + payload.channelCode + "&&personType=" + payload.personType, method: 'PUT' });
};

/**
 * 我的主页
 * @param {*} payload
 */
var agentCurrent = exports.agentCurrent = function agentCurrent(payload) {
  return (0, _request.fetch)({ url: _api.API_AGENT_CURRENT, payload: payload });
};

/**
 * 修改经纪人
 * @param {*} payload
 */
var editAgent = exports.editAgent = function editAgent(payload) {
  return (0, _request.fetch)({ url: _api.API_EDIT_AGENT + "?name=" + payload.name + "&&avatar=" + payload.avatar + "&&phone=" + payload.phone, method: 'PUT' });
};