"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.cancelFavorCard = exports.favorCard = exports.addCardShareNum = exports.queryCardFansList = exports.postFormId = exports.cancelLike = exports.addLike = exports.addCardUv = exports.applyCard = exports.getCardDetail = exports.getCardList = undefined;

var _request = require("../utils/request.js");

var _api = require("../constants/api.js");

/**
 * 获取名片列表
 * @param {*} payload 
 */
var getCardList = exports.getCardList = function getCardList(payload) {
  return (0, _request.fetch)({ url: _api.API_CARDS_LIST, payload: payload });
};

/**
 * 获取名片详情
 * @param {*} id
 */
var getCardDetail = exports.getCardDetail = function getCardDetail(id) {
  return (0, _request.fetch)({ url: _api.API_CARDS_LIST + "/" + id });
};

/**
 * 置业顾问名片绑定
 * @param {*} payload
 */
var applyCard = exports.applyCard = function applyCard(payload) {
  return (0, _request.fetch)({ url: _api.API_CARDS_APPLY, payload: payload, method: 'POST' });
};

/**
 * 名片uv埋点
 * @param {*} id  名片id
 */
var addCardUv = exports.addCardUv = function addCardUv(id) {
  return (0, _request.fetch)({ url: _api.API_CARDS_UV + "/" + id, method: 'POST' });
};

/**
 * 名片点赞
 * @param {*} id  名片id
 */
var addLike = exports.addLike = function addLike(id) {
  return (0, _request.fetch)({ url: _api.API_CARDS_LIKE + "/" + id, method: 'POST' });
};

/**
 * 名片取消点赞
 * @param {*} id  名片id
 */
var cancelLike = exports.cancelLike = function cancelLike(id) {
  return (0, _request.fetch)({ url: _api.API_CARDS_LIKE + "/" + id, method: 'DELETE' });
};

/**
 * 获取formid
 * @param {*} payload
 */
var postFormId = exports.postFormId = function postFormId(payload) {
  return (0, _request.fetch)({ url: _api.API_FORM_ID, payload: payload, method: 'POST' });
};

/**
 * 名片粉丝列表
 * @param {*} id  名片id
 */
var queryCardFansList = exports.queryCardFansList = function queryCardFansList(id, payload) {
  return (0, _request.fetch)({ url: _api.API_CARDS_UV + "/" + id, payload: payload });
};

/**
 * 名片分享埋点
 * @param {*} id  名片id
 */
var addCardShareNum = exports.addCardShareNum = function addCardShareNum(id) {
  return (0, _request.fetch)({ url: _api.API_CARDS_SHARE + "/" + id, method: 'POST' });
};

/**
 * 名片收藏
 * @param {*} payload 
 */
var favorCard = exports.favorCard = function favorCard(id) {
  return (0, _request.fetch)({ url: _api.API_CARD_FAVOR + "/" + id, method: 'POST' });
};

/**
 * 取消名片收藏
 * @param {*} payload 
 */
var cancelFavorCard = exports.cancelFavorCard = function cancelFavorCard(id) {
  return (0, _request.fetch)({ url: _api.API_CARD_FAVOR + "/" + id, method: 'DELETE' });
};