"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.uploadImage = exports.queryChatFriends = exports.queryChatHistory = exports.sendMsg = undefined;

var _request = require("../utils/request.js");

var _api = require("../constants/api.js");

/**
 * 聊天发送消息
 * @param {*} payload 
 */

var sendMsg = exports.sendMsg = function sendMsg(payload) {
  return (0, _request.fetch)({ url: _api.API_CHAT_SEND, method: 'POST', payload: payload });
};

/**
 * 获取聊天记录
 * @param {*} payload
 */
var queryChatHistory = exports.queryChatHistory = function queryChatHistory(payload) {
  return (0, _request.fetch)({ url: _api.API_CHAT_HISTORY, payload: payload });
};

/**
 * 获取好友列表 
 * @param {*} payload
 */
var queryChatFriends = exports.queryChatFriends = function queryChatFriends(payload) {
  return (0, _request.fetch)({ url: _api.API_CHAT_FRIENDS, payload: payload });
};

/**
 * 上传图片 
 * @param {*} payload
 */
var uploadImage = exports.uploadImage = function uploadImage(payload) {
  return (0, _request.fetch)({ url: _api.API_UPLOAD_IMAGE, payload: payload });
};