"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getTypeData = exports.clientProgress = exports.recommendClient = exports.getClientList = undefined;

var _request = require("../utils/request.js");

var _api = require("../constants/api.js");

/**
 * 客户列表
 * @param {*} payload 
 */
var getClientList = exports.getClientList = function getClientList(payload) {
  return (0, _request.fetch)({ url: _api.API_CLIENT_LIST, payload: payload });
};

/**
 * 推荐客户
 * @param {*} payload 
 */
var recommendClient = exports.recommendClient = function recommendClient(payload) {
  return (0, _request.fetch)({ url: _api.API_RECOMENT_CLIENT, method: 'POST', payload: payload });
};

/**
 * 客户进度详情
 * @param {*} id 
 */
var clientProgress = exports.clientProgress = function clientProgress(id) {
  return (0, _request.fetch)({ url: _api.API_CLIENT_PROGRESS + "/" + id });
};

/**
 * 选项数据查询
 * @param {*} payload 
 */
var getTypeData = exports.getTypeData = function getTypeData(payload) {
  return (0, _request.fetch)({ url: _api.API_TYPE_DATA, payload: payload });
};