"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.queryCityList = exports.updatePoint = exports.savePoint = exports.queryBanners = exports.getCodeScene = exports.getMiniQrcode = undefined;

var _request = require("../utils/request.js");

var _api = require("../constants/api.js");

/**
 * 获取二维码
 *  @param {*} payload
 * 
*/
var getMiniQrcode = exports.getMiniQrcode = function getMiniQrcode(payload) {
  return (0, _request.fetch)({ url: _api.API_QRCODE, payload: payload, method: 'POST' });
};

/**
 * 获取二维码参数
 *  @param {*} scene
 * 
*/
var getCodeScene = exports.getCodeScene = function getCodeScene(scene) {
  return (0, _request.fetch)({ url: _api.API_QUERY_CODE_SCENE + "/" + scene });
};

/**
 * 获取banner列表
 *  @param {*} type 打开方式, 这里值为 banner(轮播图) 或者 screen(首屏广告)
 *  @param {*} payload 
 * 
 * 
*/
var queryBanners = exports.queryBanners = function queryBanners(type, payload) {
  return (0, _request.fetch)({ url: _api.API_BANNER_LIST + "/" + type, payload: payload });
};

/**
 * 新增埋点
 * @param {*} payload 
 */
var savePoint = exports.savePoint = function savePoint(payload) {
  return (0, _request.fetch)({ url: _api.API_BURIED_POINT, payload: payload, method: 'POST' });
};

/**
 * 更新埋点
 * @param {*} id 
 * @param {*} payload
 */
var updatePoint = exports.updatePoint = function updatePoint(id, payload) {
  return (0, _request.fetch)({ url: _api.API_BURIED_POINT + "/" + id, payload: payload, method: 'PUT' });
};

/**
 * 获取城市列表
 * @param {*} 
 */
var queryCityList = exports.queryCityList = function queryCityList() {
  return (0, _request.fetch)({ url: _api.API_CITY_LIST });
};