"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.queryItemTypeList = exports.addItemShareNum = exports.queryItemFansList = exports.cancelFavorProject = exports.favorProject = exports.cancelLike = exports.addLike = exports.addItemUv = exports.getItemDetail = exports.getItemList = undefined;

var _request = require("../utils/request.js");

var _api = require("../constants/api.js");

/**
 * 获取项目列表
 * @param {*} payload 
 */
var getItemList = exports.getItemList = function getItemList(payload) {
  return (0, _request.fetch)({ url: _api.API_ITEMS_LIST, payload: payload });
};

/**
 * 获取项目详情
 * @param {*} id 
 */
var getItemDetail = exports.getItemDetail = function getItemDetail(id) {
  return (0, _request.fetch)({ url: _api.API_ITEMS_DETAIL + "/" + id });
};

/**
 * 项目uv埋点
 * @param {*} id  项目id
 */
var addItemUv = exports.addItemUv = function addItemUv(id) {
  return (0, _request.fetch)({ url: _api.API_ITEMS_UV + "/" + id, method: 'POST' });
};

/**
 * 项目点赞
 * @param {*} id  名片id
 */
var addLike = exports.addLike = function addLike(id) {
  return (0, _request.fetch)({ url: _api.API_ITEMS_LIKE + "/" + id, method: 'POST' });
};

/**
 * 项目取消点赞
 * @param {*} id  名片id
 */
var cancelLike = exports.cancelLike = function cancelLike(id) {
  return (0, _request.fetch)({ url: _api.API_ITEMS_LIKE + "/" + id, method: 'DELETE' });
};

/**
 *项目收藏
 * @param {*} payload 
 */
var favorProject = exports.favorProject = function favorProject(id) {
  return (0, _request.fetch)({ url: _api.API_PROJECT_FAVOR + "/" + id, method: 'POST' });
};

/**
 * 取消项目收藏
 * @param {*} payload 
 */
var cancelFavorProject = exports.cancelFavorProject = function cancelFavorProject(id) {
  return (0, _request.fetch)({ url: _api.API_PROJECT_FAVOR + "/" + id, method: 'DELETE' });
};

/**
 * 项目粉丝列表
 * @param {*} id  名片id
 */
var queryItemFansList = exports.queryItemFansList = function queryItemFansList(id, payload) {
  return (0, _request.fetch)({ url: _api.API_ITEMS_UV + "/" + id, payload: payload });
};

/**
 * 项目分享埋点
 * @param {*} id  名片id
 */
var addItemShareNum = exports.addItemShareNum = function addItemShareNum(id) {
  return (0, _request.fetch)({ url: _api.API_ITEMS_SHARE + "/" + id, method: 'POST' });
};

/**
 * 项目类型列表
 */
var queryItemTypeList = exports.queryItemTypeList = function queryItemTypeList() {
  return (0, _request.fetch)({ url: _api.API_ITEMS_TYPE });
};