"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.cancelFavorNews = exports.favorNews = exports.queryNewsDetail = exports.queryNewsList = exports.addNewsShareNum = exports.addNewsUv = undefined;

var _request = require("../utils/request.js");

var _api = require("../constants/api.js");

/**
 * 项目uv埋点
 * @param {*} id  项目id
 */
var addNewsUv = exports.addNewsUv = function addNewsUv(id) {
  return (0, _request.fetch)({ url: _api.API_NEWS_UV + "/" + id, method: 'PUT' });
};

/**
 * 项目分享埋点
 * @param {*} id  名片id
 */
var addNewsShareNum = exports.addNewsShareNum = function addNewsShareNum(id) {
  return (0, _request.fetch)({ url: _api.API_NEWS_SHARE + "/" + id, method: 'POST' });
};

/**
 * 获取资讯列表
 * @param {*} payload
 */
var queryNewsList = exports.queryNewsList = function queryNewsList(payload) {
  return (0, _request.fetch)({ url: _api.API_NEWS_LIST, payload: payload });
};

/**
 * 获取资讯详情 
 * @param {*} id
 */
var queryNewsDetail = exports.queryNewsDetail = function queryNewsDetail(id) {
  return (0, _request.fetch)({ url: _api.API_NEWS_LIST + "/" + id });
};

/**
 *资讯收藏
 * @param {*} payload 
 */
var favorNews = exports.favorNews = function favorNews(id) {
  return (0, _request.fetch)({ url: _api.API_NEWS_FAVOR + "/" + id, method: 'POST' });
};

/**
 * 取消资讯收藏
 * @param {*} payload 
 */
var cancelFavorNews = exports.cancelFavorNews = function cancelFavorNews(id) {
  return (0, _request.fetch)({ url: _api.API_NEWS_FAVOR + "/" + id, method: 'DELETE' });
};