"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.customerEdit = exports.customerGet = exports.reportClient = exports.queryReportList = undefined;

var _request = require("../utils/request.js");

var _api = require("../constants/api.js");

/**
 * 获取报备客户列表
 * @param {*} payload
 */
var queryReportList = exports.queryReportList = function queryReportList(payload) {
  return (0, _request.fetch)({ url: _api.API_REPORT_LIST, payload: payload });
};

/**
 * 报备客户
 * @param {*} payload
 */
var reportClient = exports.reportClient = function reportClient(payload) {
  return (0, _request.fetch)({ url: _api.API_REPORT_CLIENT, payload: payload, method: 'POST' });
};

/**
 * 获取客户详情
 * @param {*} payload
 */
var customerGet = exports.customerGet = function customerGet(customerId) {
  return (0, _request.fetch)({ url: _api.API_RECOMMEND_GET + "/" + customerId, method: 'GET' });
};

/**
 * 修改客户信息
 * @param {*} payload
 */
var customerEdit = exports.customerEdit = function customerEdit(payload) {
  return (0, _request.fetch)({ url: _api.API_RECOMMEND_EDIT + "/" + payload.customerId, payload: payload, method: 'PUT' });
};