"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.doUserSignin = exports.queryUserInfo = exports.queryUserPhone = exports.updateUserInfo = undefined;

var _request = require("../utils/request.js");

var _api = require("../constants/api.js");

/**
 * 更新用户信息
 * @param {*} payload 
 */
var updateUserInfo = exports.updateUserInfo = function updateUserInfo(payload) {
  return (0, _request.fetch)({ url: _api.API_USER_INFO, payload: payload, method: 'POST' });
};

/**
 * 获取用户手机号
 * @param {*} payload 
 */
var queryUserPhone = exports.queryUserPhone = function queryUserPhone(payload) {
  return (0, _request.fetch)({ url: _api.API_USER_PHONE, payload: payload, method: 'POST' });
};

/**
 * 获取用户积分 推荐客户 收藏数等
 * @param {*} payload 
 */
var queryUserInfo = exports.queryUserInfo = function queryUserInfo(payload) {
  return (0, _request.fetch)({ url: _api.API_QUERY_USER_INFO, payload: payload });
};

/**
 * 用户签到
 * @param {*} payload 
 */
var doUserSignin = exports.doUserSignin = function doUserSignin(payload) {
  return (0, _request.fetch)({ url: _api.API_USER_SIGNIN, payload: payload, method: 'POST' });
};