'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); //一个websocket调度中心类的示例


var _api = require('../constants/api.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var IMManager = function () {
  //构造消息类，需要参数：消息类型
  function IMManager() {
    _classCallCheck(this, IMManager);

    this.wss = null;
    this.socketMsgQueue = [];
    this.socketOpen = false;
    this.lockReconnect = false;
    this.limit = 12;
    this.selfClose = false;
  }

  _createClass(IMManager, [{
    key: 'reconnect',
    value: function reconnect() {
      var _this = this;

      if (this.lockReconnect) return;
      this.lockReconnect = true;
      clearTimeout(this.timer);
      console.log('reconnect');

      if (this.limit--) {
        this.timer = setTimeout(function () {
          _this.createSocket(_this.option);
          _this.lockReconnect = false;
        }, 100);
      } else {
        console.warn('您已重新连接' + this.limit + '次了,已达上限');
      }
    }

    //建立socket连接

  }, {
    key: 'createSocket',
    value: function createSocket(option) {
      var _this2 = this;

      var id = option.id,
          success = option.success,
          close = option.close,
          receive = option.receive,
          fail = option.fail;

      this.option = option;
      this.selfClose = false;

      this.wss = wx.connectSocket({
        url: _api.API_CHAT_SEND + '/' + id,
        header: {
          'content-type': 'application/json'
        },
        method: 'GET'
      });

      this.wss.onOpen(function (res) {
        _this2.socketOpen = true;
        for (var i = 0; i < _this2.socketMsgQueue.length; i++) {
          _this2.sendSocketMessage(_this2.socketMsgQueue[i]);
        }
        _this2.socketMsgQueue = [];
        success && success(res);
      });

      this.wss.onClose(function (res) {
        console.log('已关闭', res);
        close && close(res);

        // 手动关闭的就不要重启了 
        if (!_this2.selfClose) {
          _this2.reconnect();
        }
      });

      this.wss.onError(function (err) {
        console.log('打印错误', err);
        fail && fail(err);
        if (!_this2.selfClose) {
          _this2.reconnect();
        }
      });

      //接收新消息必须做点什么（判断类型，订阅DOM更新）
      // this.wss.onMessage(res => {
      //   // let message = {};
      //   // try {
      //   //   message = JSON.parse(res.data)
      //   // } catch (err) {
      //   //   message = res.data
      //   // }
      //   // this.onReceiveMessage(res)
      //   // receive && receive(res)
      //   // if (message.type) {
      //   //   switch (message.type) {
      //   //     case 'notice': //拿到了新消息
      //   //       //更新消息列表
      //   //       console.log('收到了一条消息', message)
      //   //       //监听到消息 
      //   //       //筛选本房间消息                           
      //   //       //推入视图消息队列

      //   //       break;
      //   //     case 'join':

      //   //       break;
      //   //     case 'leave':

      //   //       break;
      //   //   }
      //   // } else {
      //   //   console.log(message)
      //   // }
      // })
    }
    //组装消息

  }, {
    key: 'makeUpNotice',
    value: function makeUpNotice(send_id, consult_id, room_id, type, content, duration) {
      return {
        send_id: send_id,
        consult_id: consult_id,
        room_id: room_id,
        type: type,
        content: content,
        time_long: duration,
        read_status: type == 2 ? 0 : 1
      };
    }
  }, {
    key: 'closeSocket',
    value: function closeSocket() {
      if (this.socketOpen) {
        this.selfClose = true;
        clearTimeout(this.timer);
        wx.closeSocket({
          code: 1000,
          reason: '退出页面'
        });
        console.log('已退出 scoket');
      } else {
        console.error('scoket 没有启动');
      }
    }

    //向服务器发送notice

  }, {
    key: 'sendNotice',
    value: function sendNotice(payload, cb) {
      if (this.socketOpen) {
        this.wss.send({
          data: JSON.stringify(payload),
          success: function success(res) {
            cb && cb(res);
            console.log('socket发送成功');
          },
          fail: function fail(err) {
            console.log(err, '发送失败了');
          }
        });
      } else {
        this.socketMsgQueue.push(payload);
      }
    }
  }]);

  return IMManager;
}();

exports.default = new IMManager();