"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (params, callback) {
  if (loading) {
    return;
  }
  loading = true;
  _ready2.default.close();
  _index2.default.login({
    success: function success(_ref) {
      var code = _ref.code;

      _index2.default.showLoading();
      params.code = code;
      (0, _login.wxLogin)(params).then(function (data) {
        _index2.default.hideLoading();

        loading = false;

        var extraInfo = data.extraInfo,
            miniApp = data.miniApp,
            person = data.person,
            miniAuthorized = data.miniAuthorized;
        var token = miniApp.token,
            sessionKey = miniApp.sessionKey;

        var _getStore = (0, _index3.getStore)(),
            dispatch = _getStore.dispatch;

        _index2.default.setStorageSync('token', token);
        _index2.default.setStorageSync('sessionKey', sessionKey);

        // 用户信息已授权获取成功
        if (miniAuthorized) {
          // 保存用户信息
          dispatch({ type: _user.USER_INFO, payload: { extraInfo: extraInfo, person: person } });
          callback && callback(data);
        } else {
          _index2.default.reLaunch({
            url: '/pages/auth/index'
          });
        }
        _ready2.default.open();

        console.info('ready status2', _ready2.default);
      });
    }
  });
};

var _index = require("../npm/@tarojs/taro-weapp/index.js");

var _index2 = _interopRequireDefault(_index);

var _index3 = require("../npm/@tarojs/redux/index.js");

var _user = require("../constants/user.js");

var _login = require("../services/login.js");

var _ready = require("./ready.js");

var _ready2 = _interopRequireDefault(_ready);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var loading = false;