"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; /**
                                                                                                                                                                                                                                                                   * 适当封装 Redux，简化调用
                                                                                                                                                                                                                                                                   */
/* eslint-disable import/prefer-default-export */


exports.createAction = createAction;
exports.createActionNormal = createActionNormal;

var _request = require("./request.js");

function createAction(options) {
  var url = options.url,
      payload = options.payload,
      method = options.method,
      fetchOptions = options.fetchOptions,
      cb = options.cb,
      type = options.type;

  return function (dispatch) {
    return (0, _request.fetch)(_extends({ url: url, payload: payload, method: method }, fetchOptions)).then(function (res) {
      dispatch({ type: type, payload: cb ? cb(res) : res });
      return res;
    });
  };
}

// 跟后端不交互
function createActionNormal(options) {
  var payload = options.payload,
      type = options.type;

  return function (dispatch) {
    return new Promise(function (resolve) {
      dispatch({ type: type, payload: payload });
      resolve(payload);
    });
  };
}